﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=10
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	
#End Region

Sub Process_Globals
	Dim Ftp					As FTP
End Sub

Sub Service_Create

End Sub

Sub Service_Start (StartingIntent As Intent)
	RevisarPDFs
End Sub

Sub Service_Destroy

End Sub

Sub RevisarPDFs
	Dim lcFileName		As String = ""
	Dim lcFtpPuerto		As Int = 21
	Dim lcFtpPath		As String = "/"
	'
	Log("BEGIN: RevisarPDFs")
	'
	Log("Files to Download:")
	For i = 0 To Starter.List_Files.Size -1
		Log(Starter.List_Files.Get(i))
	Next
	'
	Try
		Ftp.PassiveMode = True
		Ftp.Initialize("ftp", "hairofthedog.dreamhost.com", lcFtpPuerto, "testftpsc", "2020FTPtest#")
		If Not(Ftp.IsInitialized) Then
			Log("Not able to initialize ftp...")
			Return
		End If
	Catch
		Log(LastException)
	End Try
	'
	Ftp.List(lcFtpPath)
	Wait for FTP_ListCompleted (ServerPath As String, Success As Boolean)
	If Success = False Then
		Starter.Last_Error	= LastException.Message
		Log("Get List failed")
		Log(Starter.Last_Error)
	End If
	'
	For i = 0 To Starter.List_Files.Size -1
		'
		lcFileName				= Starter.List_Files.Get(i)
		'lcFileName				= "/" & lcFileName
		Starter.Current_File	= lcFileName
		'
		Log("Downloading the File:")
		Log(lcFileName)
		Log("To Folder:")
		Log(Starter.SysDirApk)
		'
		Ftp.DownloadFile(lcFileName, False, Starter.SysDirApk, lcFileName)
		Wait For FTP_DownloadCompleted (ServerPath As String, Success As Boolean) '<-----
		Log($"File ${ServerPath} downloaded. Success = ${Success}"$)
		If Success = False Then
			Starter.Last_Error	= LastException.Message
			Log(Starter.Last_Error)
		End If
		'
	Next
	'
	Ftp.Close
	'
	Log("END: RevisarPDFs")

End Sub

Sub FTP_DownloadProgress (ServerPath As String, TotalDownloaded As Long, Total As Long)
	Dim s As String
	s = "Downloaded " & Round(TotalDownloaded / 1000) & "KB"
	If Total > 0 Then s = s & " out of " & Round(Total / 1000) & "KB"
	Log(s)
End Sub

Sub FTP_ListCompleted (ServerPath As String, Success As Boolean, Folders() As FTPEntry, Files() As FTPEntry)
	Log("FTP_ListCompleted")
	If Success == False Then
		Log(LastException.Message)
	Else
		For i = 0 To Files.Length - 1
			Log(Files(i).Name)
		Next
		For i = 0 To Folders.Length - 1
			Log(Folders(i).Name)
		Next
	End If
End Sub